// v0.2.6
// Need TODO
//
// 1. read a map in and sort out how to read walls.
// 4. decent gui
// 6. music - not important atm
// 8. better PNG for the HBC icon :P


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <stdarg.h>
#include <ctype.h>
#include <math.h>
#include <cstdlib> 
#include <ctime> 
#include <queue>
#include <wiiuse/wpad.h>
#include "fighter.h"
#include "globals.h"
#include "fat.h"

using namespace std;

#pragma region Globals
static GXRModeObj *rmode = NULL;

// Variables related to reading the Wiimotes
u32 wpadprobe[4];
u32 wpaddown[4];
u32 wpadheld[4];
u32 wpadup[4];
ir_t ir[4];
vec3w_t accel[4];
u32 probeType;
int evctr = 0;
float dot_size = 1;
int num_of_wiimotes = 0;
int cycles = 0;
const int map_x = 300;
const int map_y = 300;

int attack_strength = 1;
int defense_strength = 1;
int time_limit = 10000;

int my_map[map_x][map_y];
int grad_grid[4][map_x][map_y];

int army_health[4] = {0,0,0,0};


int color_p[4] = {COLOR_WHITE,COLOR_RED,COLOR_LIME,COLOR_AQUA};


struct gradient
{
	int x;
	int y;
	int value;
};

struct temp_fighters
{
	int x;
	int y;
	int team;
	int health;
};

enum Status
{
	MENU, GAME, PAUSE, WIN, HELP, SETTINGS_COLOR
};

#pragma endregion 

#pragma region Function prototypes
// Read the Wiimote and store the results in the designated variables
void updateWiimotes();
//retreives number of controllers. It will poll them and if gets a "no error"  then it is connected
int number_of_attached_controllers();
//xfb = graphics buffer, rmode = graphics mode, w = width of display?, h = height of display,
// fx = x_position to draw dot, fy = y_position to draw dot, color = color of dot...
//VI_DISPLAY_PIX_SZ == 2;
void drawdot(void *xfb, GXRModeObj *rmode, float w, float h, float fx, float fy, int team);
//no idea what is going on
void countevs(int chan, const WPADData *data);
//function to set up initial fighter position - eeds doing
void initialise_fighters(int human, int AI);
//take each fighter and draw it to the buffer
void display_fighters(void *xfb, GXRModeObj *rmode, fighter _fighter);
//Generate the gradient for each player
void gradient_fill(int team, int x, int y, int value,void *xfb, GXRModeObj *rmode);
//Move the fighter and call display_fighters
void update_fighters(void *xfb, GXRModeObj *rmode);
//Use flood fill to position the army
void seed_fighters(int x, int y, int team, int team_size);
//clear the grad_grid and set the my_map as being grad_grid
void display_map(void *xfb, GXRModeObj *rmode);
//populate my_map with one of the preset maps (map3 is random)
void generate_map(int map_no);
//check that position isnt located inside a box
bool check_position(int x, int y);
#pragma endregion

int main()
{	
	int oldx[4] = {100,100,100,100};
	int oldy[4] = {100,100,100,100};

	int comp_x[4] = {100,100,100,100};
	int comp_y[4] = {100,100,100,100};
 
	void *xfb[2];
	int fbi = 0;

	enum Status game_status;
	game_status = MENU;	

	int num_human = 0 ;
	int num_AI = 0;	
	int number_of_players = 4;

	int mod_option = 0;
	int option_attack = 1;
	int option_defense = 1;
	int option_map = 1;

	int color_option = 0;
	int selected_color[4] = {1,2,3,4};


	//VIDEO STUFF
	VIDEO_Init();
	PAD_Init();
	WPAD_Init();
 	rmode = VIDEO_GetPreferredMode(NULL);

	//double buffered
	xfb[0] = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	xfb[1] = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
 
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) 
	{
		VIDEO_WaitVSync();
	}



	for(int t = 0; t < 4; t++)	//loop thru all 4 controllers
	{
		WPAD_SetDataFormat(t, WPAD_FMT_BTNS_ACC_IR);
		WPAD_SetVRes(t, rmode->fbWidth, rmode->xfbHeight);	//set resolution of wiimotes to that of the wii (all channels)
	}	
	

	updateWiimotes(); 

	

	while(1) //actual program stuff
	{
		CON_Init(xfb[fbi],0,0,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
			
		// Read Wiimote again		
		updateWiimotes();
		
		//TODO: implement better menu
		if(game_status == GAME)
		{
			cycles++;
						
			if(cycles%150 == 1)	//refresh the number of controllers
			{
				num_of_wiimotes = number_of_attached_controllers();

				num_human = num_of_wiimotes;
				num_AI = number_of_players - num_human;			
			}

			if(cycles%20 == 1)	
			{
				//take any computer player and assign to random position in map
				for(int comp_player = num_human; comp_player < number_of_players; comp_player++)
				{
					ir[comp_player].valid = 1;

					if(army_health[comp_player] != 0)
					{
						for(int _count = 0;_count<20;_count++)
						{
							srand(time(NULL));
							fighter Rfighter = my_fighter[rand()%num_of_fighters];
							if(Rfighter.team != comp_player+1)
							{
								comp_x[comp_player] = Rfighter.x;
								comp_y[comp_player] = Rfighter.y;
								break;
							}
						}			
					}

					//srand(cycles*time(NULL));
					//comp_x[comp_player] = (rand()%(map_x-4)) + 2;
					//srand(rand()%1000);
					//comp_y[comp_player] = (rand()%(map_y-4)) + 2;					
				}				
			}

			//need to refresh every cycle otherwise above update_wiimote blanks it
			for(int comp_player = num_human; comp_player < number_of_players; comp_player++)
			{
				ir[comp_player].x = comp_x[comp_player];
				ir[comp_player].y = comp_y[comp_player];
			}

			update_fighters(xfb[fbi],rmode);
			//clear current gradient, and output lines of the map
			display_map(xfb[fbi], rmode);

			for(int my_wiimote = 0; my_wiimote < number_of_players; my_wiimote++)
			{
				if(ir[my_wiimote].valid)	//if a valid number then draw on the screen (turns out to be a square over 20x20
				{
					oldx[my_wiimote]=ir[my_wiimote].x;
					oldy[my_wiimote]=ir[my_wiimote].y;
					//VIDEO STUFF
					drawdot(xfb[fbi], rmode, rmode->fbWidth, rmode->xfbHeight, ir[my_wiimote].x, ir[my_wiimote].y, my_wiimote);
				}
				else	//if not valid keep the dot on the last place recorded
				{
					//VIDEO STUFF
					drawdot(xfb[fbi], rmode, rmode->fbWidth, rmode->xfbHeight, oldx[my_wiimote], oldy[my_wiimote], my_wiimote);
				}
				
				//if a player is still alive then calculate his gradient
				if(army_health[my_wiimote] != 0)
				{
					//VIDEO STUFF
					gradient_fill(my_wiimote, oldx[my_wiimote], oldy[my_wiimote],1, xfb[fbi],rmode);
				}
			}

			//get the army health, and move and display the fighters

			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_HOME)
			{
				updateWiimotes();
				game_status = PAUSE;				
			}

			if(WPAD_ButtonsHeld(0) & WPAD_BUTTON_B)
			{
				if(ir[0].valid && option_map == 3)
				{
					if(my_map[oldx[0]][oldy[0]] == -1)
					{
						my_map[oldx[0]][oldy[0]] = 0;
					}
					if(my_map[oldx[0]+1][oldy[0]+1] == -1)
					{
						my_map[oldx[0]+1][oldy[0]+1] = 0;
					}
					if(my_map[oldx[0]+1][oldy[0]] == -1)
					{
						my_map[oldx[0]+1][oldy[0]] = 0;
					}
					if(my_map[oldx[0]][oldy[0]+1] == -1)
					{
						my_map[oldx[0]][oldy[0]+1] = 0;
					}

				}
			}

			printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCycles:%i P1:%i P2:%i P3:%i P4:%i ",cycles,  army_health[0], army_health[1], army_health[2], army_health[3]);


	//------Win conditions------//
			if(army_health[0] == num_of_fighters)
			{
				game_status = WIN;
			}
			else if(army_health[1] == num_of_fighters)
			{
				game_status = WIN;
			}
			else if(army_health[2] == num_of_fighters)
			{
				game_status = WIN;
			}
			else if(army_health[3] == num_of_fighters)
			{
				game_status = WIN;
			}

			u32 type;
			if((WPAD_ButtonsDown(0) &  WPAD_BUTTON_2) || WPAD_Probe(0, &type) != WPAD_ERR_NONE)
			{			
				if((WPAD_ButtonsDown(1) &  WPAD_BUTTON_2) || WPAD_Probe(1, &type) != WPAD_ERR_NONE)
				{			
					if((WPAD_ButtonsDown(2) &  WPAD_BUTTON_2) || WPAD_Probe(2, &type) != WPAD_ERR_NONE)
					{			
						if((WPAD_ButtonsDown(3) &  WPAD_BUTTON_2) || WPAD_Probe(3, &type) != WPAD_ERR_NONE)
						{			
							game_status = WIN;
						}
					}
				}
			}
			if(cycles == time_limit)
			{
				game_status = WIN;
			}
	//------Win conditions------//
		}		
		else if(game_status == MENU)
		{					
			num_of_wiimotes = number_of_attached_controllers();

			num_human = num_of_wiimotes;
			num_AI = number_of_players - num_human;

			printf("---Menu---");
			printf("\n\nPress Home to quit to HBC\nPress 1 for Help\nPress A to start game...");
			
			printf("\n\n\n\n\n--Settings--");
			
			switch(mod_option)
			{
				case 1:
					printf("\n  Attack:<%i/10>",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map: %i ", option_map);
					printf("\n  Number of players: %i", number_of_players);
					printf("\n  Time Limit: %i ", time_limit);
					printf("\n  Color Settings");
					break;
				case 2:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense:<%i/10>",option_defense);
					printf("\n  Map: %i ", option_map);
					printf("\n  Number of players: %i", number_of_players);
					printf("\n  Time Limit: %i ", time_limit);
					printf("\n  Color Settings");
					break;
				case 3:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map:<%i/3>", option_map);
					printf("\n  Number of players: %i", number_of_players);
					printf("\n  Time Limit: %i ", time_limit);
					printf("\n  Color Settings");
					break;
				case 4:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map: %i ", option_map);
					printf("\n  Number of players:<%i/4>", number_of_players);
					printf("\n  Time Limit: %i ", time_limit);
					printf("\n  Color Settings");
					break;
				case 5:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map: %i ", option_map);
					printf("\n  Number of players: %i", number_of_players);
					printf("\n  Time Limit:<%i>", time_limit);
					printf("\n  Color Settings");
					break;
				case 6:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map: %i ", option_map);
					printf("\n  Number of players: %i", number_of_players);
					printf("\n  Time Limit: %i", time_limit);
					printf("\n  Color Settings - Press Right");
					break;

				default:
					printf("\n  Attack: %i ",option_attack);
					printf("\n  Defense: %i ",option_defense);
					printf("\n  Map: %i ", option_map);			
					printf("\n  Number of players: %i", number_of_players);		
					printf("\n  Time Limit: %i ", time_limit);
					printf("\n  Color Settings");
					break;
			}

				
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_DOWN)
			{			
				mod_option++;
				if(mod_option == 7)
				{
					mod_option = 0;
				}
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_UP)
			{			
				mod_option--;
				if(mod_option == -1)
				{
					mod_option = 6;
				}
			}

			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_RIGHT)
			{			
				if(mod_option == 1)
				{
					if(option_attack <10)
						option_attack++;
				}
				else if(mod_option == 2)
				{
					if(option_defense <10)
						option_defense++;
				}
				else if(mod_option == 3)
				{
					if(option_map < 3)
						option_map++;
				}
				else if(mod_option == 4)
				{				
					if(number_of_players < 4)
						number_of_players++;				
				}
				else if(mod_option == 5)
				{
					if(time_limit < 10000)
						time_limit += 100;
				}
				else if(mod_option == 6)
				{
					game_status = SETTINGS_COLOR;
				}
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_LEFT)
			{			
				if(mod_option == 1)
				{
					if(option_attack>1 )
						option_attack--;
				}
				else if(mod_option == 2)
				{
					if(option_defense >1 )
						option_defense--;
				}
				else if(mod_option == 3)
				{
					if(option_map >1)
						option_map--;
				}
				else if(mod_option == 4)
				{
					if(number_of_players > 2)
						number_of_players--;
				}
				else if(mod_option == 5)
				{
					if(time_limit > 1000)
						time_limit -= 100;
				}
				else if(mod_option == 6)
				{
					game_status = SETTINGS_COLOR;
				}
			}
			if(WPAD_ButtonsHeld(0) &  WPAD_BUTTON_PLUS)
			{			
				if(mod_option == 5)
				{
					if(time_limit < 10000)
							time_limit += 100;
						else
							time_limit = 10000;
				}
			}
			if(WPAD_ButtonsHeld(0) &  WPAD_BUTTON_MINUS)
			{			
				if(mod_option == 5)
				{
					if(time_limit > 1000)
						time_limit -= 100;
					else
						time_limit = 1000;
				}
			}

			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_1)
			{
				game_status = HELP;
			}
			
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_HOME)
			{			
				exit(0);
			}
			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_A)
			{
				generate_map(option_map);
				
				for(int count = 0; count<number_of_players; count++)
				{
					for(int _map_x = 0; _map_x < map_x; _map_x++)
					{
						for(int _map_y = 0; _map_y < map_y; _map_y++)
						{
							grad_grid[count][_map_x][_map_y] = my_map[_map_x][_map_y];
						}
					}					
				}

				//Randomly place the armies
				for(int rand_team = 0;rand_team < number_of_players; rand_team++)
				{
					srand(time(NULL));
					int exit = 1;
					while(exit == 1)
					{							
						srand(rand()%1000);

						int rand_x = (rand()%(map_x-4)) + 2;
						srand(rand()%100);
						int rand_y = (rand()%(map_y-4)) + 2;

						if(my_map[rand_x][rand_y] == 0)
						{					
							seed_fighters(rand_x,rand_y,rand_team,(num_of_fighters/number_of_players));
							exit = 0;
						}
					}
				}			

				attack_strength = option_attack;
				defense_strength = option_defense;

				game_status = GAME;
			}
		}//end if(game_status == MENU)


		else if(game_status == PAUSE)
		{			
			printf("--Paused--\n\n\nHome - Returns to HBC.\nA    - Returns to the game.\nB    - Returns to the Menu. ");
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_HOME)
			{		
				exit(0);
			}
			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_A)
			{
				game_status = GAME;
			}
			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_B)
			{
				cycles = 0;
				game_status = MENU;
			}
		}//end if(game_status == PAUSE)
		else if(game_status == WIN)
		{
			int winning_team = 0;
			int winning_size = 0;
			for(int _team = 0; _team < number_of_players; _team++)
			{
				if(army_health[_team]>winning_size)
				{
					winning_size = army_health[_team];
					winning_team = _team;
				}
			}
			printf("--Player %i Won--\n\nCongratulations! You won this time, and in only %i cycles.\n\nCan you do it again?\n\nPress A to return to the menu, or Home to quit.",winning_team+1,cycles);
			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_A)
			{
				cycles = 0;
				game_status = MENU;
			}
			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_HOME)
			{
				exit(0);
			}
		}
		else if(game_status == HELP)
		{
			printf("--Hello and welcome to Liqwiid Wars!--");
			printf("\nLiqwiid Wars is based around an existing game Liquid Wars found at ");
			printf(" http://www.ufoot.org/liquidwar, however the code was writen entired from ");
			printf(" scratch using conversations with Christian Mauduit and in-game activity as ");
			printf(" the inspiration. It has been made possible due to the people behind http://forum.wiibrew.org/, ");
			printf("DevkitPro, codemii.com, Team Twiizers and many more I am sure I have forgotten. \n\n Thanks for downloading! \n   Steaky    ");

			printf("\n\n--Instructions--");
			printf("\nYour cursor controls a single army of deadly fighters. These fighters wear armour the same color as your cursor.\nThe aim is to attack the enemies armies.");
			printf("\nWhen a fighter breathes his dying breath he is turned by the attacker and joins the attackers army.");
			
			printf("\n\n--Settings--");			
			printf("\n  Attack - The amount of damage each fighter will deal out.");
			printf("\n  Defense - The amount a fighter will be healed by an ally.");
			printf("\n  Map - Different maps to choose from. Map 3 is a randomly generated map - This might cause an army to become trapped. Player 1 can break the wall down with the B button.");
			printf("\n  Number of players - This is the total number of players.");
			printf("\n  Time Limit - When the time limit is reached, the player with the most fighters win.");

			printf("\n\nPress Home to quit to the HBC or B to return to the Menu.");
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_HOME)
			{		
				exit(0);
			}

			if(WPAD_ButtonsDown(0) & WPAD_BUTTON_B)
			{
				cycles = 0;
				game_status = MENU;
			}

		}
		else if(game_status == SETTINGS_COLOR)
		{
			printf("--Color Settings--");

			switch(color_option)
			{
				case 1:
					printf("\n\n->Player 1");
					printf("\n  Player 2");
					printf("\n  Player 3");
					printf("\n  Player 4");					
					break;
				case 2:
					printf("\n\n  Player 1");
					printf("\n->Player 2");
					printf("\n  Player 3");
					printf("\n  Player 4");
					break;
				case 3:
					printf("\n\n  Player 1");
					printf("\n  Player 2");
					printf("\n->Player 3");
					printf("\n  Player 4");
					break;
				case 4:
					printf("\n\n  Player 1");
					printf("\n  Player 2");
					printf("\n  Player 3");
					printf("\n->Player 4");
					break;
				default:
					printf("\n\n  Player 1");
					printf("\n  Player 2");
					printf("\n  Player 3");
					printf("\n  Player 4");
					break;
			}

			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_RIGHT)
			{			
					selected_color[color_option-1]++;
					if(selected_color[color_option-1] == 8)
						selected_color[color_option-1] =7;
				
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_LEFT)
			{			
				
					selected_color[color_option-1]--;
					if(selected_color[color_option-1] == 0)
						selected_color[color_option-1] = 1;
				
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_UP)
			{			
				color_option--;
				if(color_option == 0)
					color_option = 1;
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_DOWN)
			{			
				color_option++;
				if(color_option == 5)
					color_option = 4;
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_B)
			{
				game_status = MENU;
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_A)
			{
				game_status = MENU;
			}
			if(WPAD_ButtonsDown(0) &  WPAD_BUTTON_HOME)
			{
				game_status = MENU;
			}
			
			if(color_option>0)
			{
				switch(selected_color[color_option-1])
				{
					case 1:
						color_p[color_option-1] = COLOR_WHITE;
						break;
					case 2:
						color_p[color_option-1] = COLOR_RED;
						break;
					case 3:
						color_p[color_option-1] = COLOR_LIME;
						break;
					case 4:
						color_p[color_option-1] = COLOR_AQUA;
						break;
					case 5:
						color_p[color_option-1] = COLOR_MONEYGREEN;
						break;
					case 6:
						color_p[color_option-1] = COLOR_PURPLE;
						break;
					case 7:
						color_p[color_option-1] = COLOR_FUCHSIA;
						break;
				}
			}
			drawdot(xfb[fbi], rmode, rmode->fbWidth+5, rmode->xfbHeight+5, 100, 40, 0);
			drawdot(xfb[fbi], rmode, rmode->fbWidth+5, rmode->xfbHeight+5, 100, 60, 1);
			drawdot(xfb[fbi], rmode, rmode->fbWidth+5, rmode->xfbHeight+5, 100, 80, 2);
			drawdot(xfb[fbi], rmode, rmode->fbWidth+5, rmode->xfbHeight+5, 100,100, 3);

		}
		
		// Finally, render graphics to screen
		VIDEO_SetNextFramebuffer(xfb[fbi]);
		VIDEO_Flush();
		VIDEO_WaitVSync();
		fbi ^= 1;	//flips between 1 and 0 - flips buffers
    }

    return 0;
}

// Read the Wiimote and store the results in the designated variables
void updateWiimotes() {
	WPAD_ScanPads();
	for(int t = 0; t < 4; t++) {
		wpadprobe[t] = WPAD_Probe(t, &probeType);
		wpaddown[t] = WPAD_ButtonsDown(t);
		wpadheld[t] = WPAD_ButtonsHeld(t);
		wpadup[t] = WPAD_ButtonsUp(t);
		WPAD_IR(t, &ir[t]);
		WPAD_Accel(t, &accel[t]);
	}
}

//retreives number of controllers. It will poll them and if gets a "no error"  then it is connected
int number_of_attached_controllers() {
  int i, num_attached=0;
  u32 type;  //expansion type, not used in this example

  for(i=0; i<WPAD_MAX_WIIMOTES; i++) {
    if (WPAD_Probe(i, &type) == WPAD_ERR_NONE) {
      num_attached++;
    }
  }
  return num_attached;
}


//draw a dot the specified position
void drawdot(void *xfb, GXRModeObj *rmode, float w, float h, float fx, float fy, int team) {
//xfb = graphics buffer, rmode = graphics mode, w = width of display?, h = height of display,
// fx = x_position to draw dot, fy = y_position to draw dot, color = color of dot...
//VI_DISPLAY_PIX_SZ == 2;
	u32 *fb;
	int px,py;
	int x,y;
	fb = (u32*)xfb;
	int color = COLOR_WHITE;
 
	y = fy * rmode->xfbHeight / h;	
	x = fx * rmode->fbWidth / w / 2;

	color = color_p[team];

	/*switch(team)
	{
		case 0:
			color = color_P1;
			break;
		case 1:
			color = color_P2;
			break;
		case 2:
			color = color_P3;
			break;
		case 3:
			color = color_P4;
			break;		
		default:
			color = COLOR_BLACK;
			break;
	}*/
 
	for(py=y-(2*dot_size); py<=(y+(2*dot_size)); py++) 
	{
		if(py < 0 || py >= rmode->xfbHeight)	
				continue;						//ignore everything after
		
		for(px=x-dot_size; px<=(x+dot_size); px++) 
		{
			if(px < 0 || px >= rmode->fbWidth/2)
				continue;						//ignore everything after
			fb[rmode->fbWidth/VI_DISPLAY_PIX_SZ*py + px] = color; //draw to buffer
			//VIDEO STUFF			
		}
	}
 
}
//no idea what is going on :p
void countevs(int chan, const WPADData *data) 
{
	evctr++;
}
//use the fighter.team to set the color
void display_fighters(void *xfb, GXRModeObj *rmode, fighter _fighter)
{
	u32 *fb;
	fb = (u32*)xfb;
	u32 _color ;

	_color = color_p[_fighter.team];
	/*switch(_fighter.team)
	{
	case 0:
		_color = color_P1;
		break;
	case 1:
		_color = color_P2;
		break;
	case 2:
		_color = color_P3;
		break;
	case 3:
		_color = color_P4;
		break;
	case 4:
	default:
		_color = COLOR_BLACK;
		break;

	}*/
	//VIDEO STUFF
	fb[rmode->fbWidth/VI_DISPLAY_PIX_SZ*_fighter.y + (_fighter.x/2)] = _color;		
}


//Generate the gradient for each player
void gradient_fill(int team, int x, int y, int value,void *xfb, GXRModeObj *rmode)
{
//Flood-fill (node, target-color, replacement-color):
// 1. Set Q to the empty queue.
// 2. If the color of node is not equal to target-color, return.
// 3. Add node to the end of Q.
// 4. While Q is not empty: 
// 5.     Set n equal to the first element of Q
// 6.     If the color of n is equal to target-color, set the color of n to replacement-color.
// 7.     Remove first element from Q
// 8.     If the color of the node to the west of n is target-color, set the color of that node to replacement-color, add that node to the end of Q.
// 9.     If the color of the node to the east of n is target-color, set the color of that node to replacement-color, add that node to the end of Q.
// 10.    If the color of the node to the north of n is target-color, set the color of that node to replacement-color, add that node to the end of Q.
// 11.    If the color of the node to the south of n is target-color, set the color of that node to replacement-color, add that node to the end of Q.
// 12. Return.
	std::queue<gradient> gradient_queue;

	gradient temp_grad;
	temp_grad.x = x;
	temp_grad.y = y;
	temp_grad.value = value;

	u32 *fb;
	fb = (u32*)xfb;

	int interations = 0;	
	
	//put first position onto queue

	gradient_queue.push(temp_grad);
	
	do
	{		
		//look at the front element then throw first element away...
		
		temp_grad = gradient_queue.front();
		gradient_queue.pop();
		interations++;
		
		
		x = temp_grad.x;
		y = temp_grad.y;
		
		grad_grid[team][x][y] = temp_grad.value;

		temp_grad.value++;

		//if(x<map_x-2 && x>0 && y<map_y-2 && y>0)
			
		if (x >= map_x - 2 || x <= 0 || y >= map_y - 2 || y <= 0) continue;
				
		if(grad_grid[team][temp_grad.x+1][temp_grad.y] > temp_grad.value || grad_grid[team][temp_grad.x+1][temp_grad.y] ==0)
		{
			temp_grad.x = x+1;
			grad_grid[team][temp_grad.x][temp_grad.y] = 1;
			gradient_queue.push(temp_grad);
			temp_grad.x = x;
		}
		if(grad_grid[team][temp_grad.x][temp_grad.y-1] > temp_grad.value || grad_grid[team][temp_grad.x][temp_grad.y-1] ==0)
		{
			temp_grad.y = y-1;
			grad_grid[team][temp_grad.x][temp_grad.y] = 1;
			gradient_queue.push(temp_grad);
			temp_grad.y = y;
		}
		if(grad_grid[team][temp_grad.x][temp_grad.y+1] > temp_grad.value || grad_grid[team][temp_grad.x][temp_grad.y+1] ==0)
		{
			temp_grad.y = y+1;
			grad_grid[team][temp_grad.x][temp_grad.y] = 1;
			gradient_queue.push(temp_grad);
			temp_grad.y = y;
		}
		if(grad_grid[team][temp_grad.x-1][temp_grad.y] > temp_grad.value || grad_grid[team][temp_grad.x-1][temp_grad.y] ==0)
		{
			temp_grad.x = x-1;
			grad_grid[team][temp_grad.x][temp_grad.y] = 1;
			gradient_queue.push(temp_grad);
			temp_grad.x = x;
		}
		
		if(interations >= 500000)
			break;
	}
	while(!gradient_queue.empty());
}
//Move the fighter and call display_fighters
void update_fighters(void *xfb, GXRModeObj *rmode)
{
	army_health[0] = 0;
	army_health[1] = 0;
	army_health[2] = 0;
	army_health[3] = 0;
	for(int this_fighter = 0; this_fighter<num_of_fighters; this_fighter++)
	{
        int fighter_x = my_fighter[this_fighter].x;
        int fighter_y = my_fighter[this_fighter].y;
        int fighter_team = my_fighter[this_fighter].team; 
		
		int best_direction = 0;
        int good_direction = 0;
        int OK_direction = 0;

		int chosen_direction = 0;

        int OK_grad = grad_grid[fighter_team][fighter_x][fighter_y];
        int good_grad = OK_grad - 1;
        int best_grad = good_grad - 1;
	
		int neighbour_G_dir = 0;		
		int friend_B_dir = 0;
		int enemy_B_dir = 0;

		u32 *fb;
		fb = (u32*)xfb;

		army_health[fighter_team]+=1;


        if (fighter_x < map_x - 2 && fighter_x > 0 && fighter_y < map_y - 2 && fighter_y > 0)
        {
            //best direction
            //good direction
            //ok direction

            //look at 8 neighbours....            

			//-1 -1//
				
			if(my_map[fighter_x-1][fighter_y-1] == 0)
			{
				if (grad_grid[fighter_team][fighter_x -1][fighter_y -1] == best_grad)
				{
					best_direction += 1;
				}
				else if (grad_grid[fighter_team][ fighter_x -1][ fighter_y -1] == good_grad )
				{
					good_direction += 1;
				}
				else if (grad_grid[fighter_team][ fighter_x -1][ fighter_y -1] == OK_grad )
				{
					OK_direction += 1;
				}
			}

			//-1 0//
			if(my_map[fighter_x-1][ fighter_y] == 0)
			{
				if (grad_grid[fighter_team][ fighter_x -1][ fighter_y ] == best_grad )
				{
					best_direction += 2;
				}
				else if (grad_grid[fighter_team][ fighter_x -1][ fighter_y ] == good_grad)
				{
					good_direction += 2;
				}
				else if (grad_grid[fighter_team][ fighter_x -1][fighter_y ] == OK_grad)
				{
					OK_direction += 2;
				}
			}


			//-1 +1//
			if(my_map[fighter_x-1][ fighter_y+1] == 0)
			{
				if (grad_grid[fighter_team][ fighter_x -1][fighter_y +1] == best_grad)
				{
					best_direction += 4;
				}
				else if (grad_grid[fighter_team][fighter_x -1][ fighter_y +1] == good_grad)
				{
					good_direction += 4;
				}
				else if (grad_grid[fighter_team][ fighter_x -1][fighter_y +1] == OK_grad)
				{
					OK_direction += 4;
				}
			}

			//0 -1//
			if(my_map[fighter_x][ fighter_y-1] == 0)
			{            
				if (grad_grid[fighter_team][ fighter_x ][fighter_y -1] == best_grad)
				{
					best_direction += 8;
				}
				else if (grad_grid[fighter_team][ fighter_x ][ fighter_y -1] == good_grad)
				{
					good_direction += 8;
				}
				else if (grad_grid[fighter_team][ fighter_x][ fighter_y -1] == OK_grad)
				{
					OK_direction += 8;
				}
			}

			//0 +1//
			if(my_map[fighter_x][ fighter_y+1] == 0)
			{					
				if (grad_grid[fighter_team][ fighter_x][ fighter_y +1] == best_grad )
				{
					best_direction += 16;
				}
				else if (grad_grid[fighter_team][ fighter_x][ fighter_y +1] == good_grad)
				{
					good_direction += 16;
				}
				else if (grad_grid[fighter_team][ fighter_x][ fighter_y +1] == OK_grad )
				{
					OK_direction += 16;
				}
			}

			//+1 -1//
			if(my_map[fighter_x+1][ fighter_y-1] == 0)
			{
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y -1] == best_grad)
				{
					best_direction += 32;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y -1] == good_grad)
				{
					good_direction += 32;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y -1] == OK_grad)
				{
					OK_direction += 32;
				}
			}

			//+1 0//
			if(my_map[fighter_x+1][ fighter_y] == 0)
			{
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y ] == best_grad )
				{
					best_direction += 64;
				}
				else 
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y ] == good_grad)
				{
					good_direction += 64;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y ] == OK_grad)
				{
					OK_direction += 64;
				}
			}

			//+1 +1//
			if(my_map[fighter_x+1][ fighter_y+1] == 0)
			{
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y +1] == best_grad)
				{
					best_direction += 128;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y +1] == good_grad)
				{
					good_direction += 128;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y +1] == OK_grad)
				{
					OK_direction += 128;
				}    
			}

            if (best_direction != 0)//if can move in best direction then do it...
            {
               chosen_direction = best_direction;
            }
            else if (good_direction != 0) //if cant do best, but can do good then do that
            {
                chosen_direction = good_direction;
            }
            else if (OK_direction != 0) //if cant do best or ood, but can do OK direction do that then
            {
                chosen_direction = OK_direction;
            }
			else
			{
	
				//no clear directions....
				if (grad_grid[fighter_team][fighter_x -1][fighter_y -1] == best_grad && my_map[fighter_x-1][fighter_y-1] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y-1] - 1].team == fighter_team)
						friend_B_dir += 1;
					else
						enemy_B_dir += 1;
						
				}
				else if (grad_grid[fighter_team][ fighter_x -1][ fighter_y -1] == good_grad && my_map[fighter_x -1][ fighter_y -1] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y-1] - 1].team != fighter_team)
						neighbour_G_dir += 1;
				}

				//-1 0//
				if (grad_grid[fighter_team][ fighter_x -1][ fighter_y ] == best_grad && my_map[fighter_x-1][ fighter_y] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y] - 1].team == fighter_team)
						friend_B_dir += 2;
					else
						enemy_B_dir += 2;
				}
				else 
				if (grad_grid[fighter_team][ fighter_x -1][ fighter_y ] == good_grad && my_map[fighter_x -1][ fighter_y ] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y] - 1].team != fighter_team)
						neighbour_G_dir += 2;
				}

				//-1 +1//
				if (grad_grid[fighter_team][ fighter_x -1][fighter_y +1] == best_grad && my_map[fighter_x-1][fighter_y+1] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y+1] - 1].team == fighter_team)
						friend_B_dir += 4;
					else
						enemy_B_dir += 4;
				}
				else if (grad_grid[fighter_team][fighter_x -1][ fighter_y +1] == good_grad && my_map[fighter_x -1][fighter_y +1] > 0)
				{
					if(my_fighter[my_map[fighter_x-1][fighter_y+1] - 1].team != fighter_team)
						neighbour_G_dir += 4;
				}

				//0 -1//
				if (grad_grid[fighter_team][ fighter_x ][fighter_y -1] == best_grad && my_map[fighter_x][fighter_y-1] > 0)
				{
					if(my_fighter[my_map[fighter_x][fighter_y-1] - 1].team == fighter_team)
						friend_B_dir += 8;
					else
						enemy_B_dir += 8;
				}
				else if (grad_grid[fighter_team][ fighter_x ][ fighter_y -1] == good_grad && my_map[fighter_x][ fighter_y -1] > 0)
				{
					if(my_fighter[my_map[fighter_x][fighter_y-1] - 1].team != fighter_team)
						neighbour_G_dir += 8;
				}

				//0 +1//
				if (grad_grid[fighter_team][ fighter_x][ fighter_y +1] == best_grad && my_map[fighter_x][ fighter_y+1] > 0)
				{
					if(my_fighter[my_map[fighter_x][fighter_y+1] - 1].team == fighter_team)
						friend_B_dir += 16;
					else
						enemy_B_dir += 16;
				}
				else if (grad_grid[fighter_team][ fighter_x][ fighter_y +1] == good_grad && my_map[fighter_x -1][ fighter_y +1] > 0)
				{
					if(my_fighter[my_map[fighter_x][fighter_y+1] - 1].team != fighter_team)
						neighbour_G_dir += 16;
				}

				//+1 -1//
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y -1] == best_grad && my_map[fighter_x+1][ fighter_y-1] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y-1] - 1].team == fighter_team)
						friend_B_dir += 32;
					else
						enemy_B_dir += 32;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y -1] == good_grad && my_map[fighter_x -1][ fighter_y -1] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y-1] - 1].team != fighter_team)
						neighbour_G_dir += 32;
				}

				//+1 0//
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y ] == best_grad && my_map[fighter_x+1][ fighter_y] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y] - 1].team == fighter_team)
						friend_B_dir += 64;
					else
						enemy_B_dir += 64;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y ] == good_grad && my_map[fighter_x +1][ fighter_y ] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y] - 1].team != fighter_team)
						neighbour_G_dir += 64;
				}

				//+1 +1//
				if (grad_grid[fighter_team][ fighter_x +1][ fighter_y +1] == best_grad && my_map[fighter_x+1][ fighter_y+1] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y+1] - 1].team == fighter_team)
						friend_B_dir += 128;
					else
						enemy_B_dir += 128;
				}
				else if (grad_grid[fighter_team][ fighter_x +1][ fighter_y +1] == good_grad && my_map[fighter_x +1][ fighter_y +1] > 0)
				{
					if(my_fighter[my_map[fighter_x+1][fighter_y+1] - 1].team != fighter_team)
						neighbour_G_dir += 128;
				}

	
			}

			if(best_direction+good_direction+OK_direction != 0)
			{
				switch(chosen_direction)
				{
					srand(chosen_direction*(fighter_x/fighter_y));

					case 129://SE || NW
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( 1, 1);
							my_map[fighter_x+1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( -1, -1);
							my_map[fighter_x-1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;
					case 36://NE || SW
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( -1, 1);
							my_map[fighter_x-1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( 1, -1);
							my_map[fighter_x+1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;
					case 33://NW || SW
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( -1, -1);
							my_map[fighter_x-1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( 1, -1);
							my_map[fighter_x+1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;
					case 132://SE || NE
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( 1, 1);
							my_map[fighter_x+1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( -1, 1);
							my_map[fighter_x-1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;
					case 5://NW || NE
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( -1, -1);
							my_map[fighter_x-1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( -1, 1);
							my_map[fighter_x-1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;
					case 160://SW || SE
						if(rand()%10 < 5)
						{
							my_fighter[this_fighter].move_fighter( 1, -1);
							my_map[fighter_x+1][fighter_y-1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						else
						{
							my_fighter[this_fighter].move_fighter( 1, 1);
							my_map[fighter_x+1][fighter_y+1] = this_fighter+1;
							my_map[fighter_x][fighter_y] = 0;
						}
						break;


					case 1: //NW
						my_fighter[this_fighter].move_fighter(-1,-1);
						my_map[fighter_x-1][fighter_y-1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 2: //N
						my_fighter[this_fighter].move_fighter(-1,0);
						my_map[fighter_x-1][fighter_y] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 4: //NE
						my_fighter[this_fighter].move_fighter(-1, 1);
						my_map[fighter_x-1][fighter_y+1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 8: //W
						my_fighter[this_fighter].move_fighter(0,-1);
						my_map[fighter_x][fighter_y-1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 16: //E
						my_fighter[this_fighter].move_fighter(0, 1);
						my_map[fighter_x][fighter_y+1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 32: //SW
						my_fighter[this_fighter].move_fighter( 1,-1);
						my_map[fighter_x+1][fighter_y-1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 64: //S
						my_fighter[this_fighter].move_fighter( 1,0);
						my_map[fighter_x+1][fighter_y] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
					case 128: //SE
						my_fighter[this_fighter].move_fighter( 1, 1);
						my_map[fighter_x+1][fighter_y+1] = this_fighter+1;
						my_map[fighter_x][fighter_y] = 0;
						break;
				}
			}
			else
			{
				if(enemy_B_dir != 0)
				{
					switch(enemy_B_dir)
					{
						srand(enemy_B_dir*(fighter_x/fighter_y));

						case 1: //NW
							//my_fighter[this_fighter].move_fighter(-1,-1);
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							break;
						case 2: //N
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1,0);

							break;
						case 4: //NE
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1, 1);
							break;
						case 8: //W
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0,-1);
							break;
						case 16: //E
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0, 1);
							break;
						case 32: //SW
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,-1);
							break;
						case 64: //S
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,0);
							break;
						case 128: //SE
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1, 1);
							break;

						case 129://SE || NW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							break;
						case 36://NE || SW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 33://NW || SW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 132://SE || NE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 5://NW || NE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 160://SW || SE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							break;					
					}
				}
				else if(neighbour_G_dir != 0)
				{
					switch(neighbour_G_dir)
					{
						srand(neighbour_G_dir*(fighter_x/fighter_y));

						case 1: //NW
							//my_fighter[this_fighter].move_fighter(-1,-1);
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							break;
						case 2: //N
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1,0);

							break;
						case 4: //NE
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1, 1);
							break;
						case 8: //W
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0,-1);
							break;
						case 16: //E
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0, 1);
							break;
						case 32: //SW
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,-1);
							break;
						case 64: //S
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,0);
							break;
						case 128: //SE
							my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
							my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1, 1);
							break;

						case 129://SE || NW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							break;
						case 36://NE || SW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 33://NW || SW
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 132://SE || NE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 5://NW || NE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 160://SW || SE
							if(rand()%10 < 5)
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							else
							{
								my_fighter[this_fighter].change_health(fighter_team, attack_strength, defense_strength);
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							break;					
					}
				}
				else if(friend_B_dir != 0)
				{
					switch(friend_B_dir)
					{
						srand(friend_B_dir*(fighter_x/fighter_y));

						case 1: //NW
							//my_fighter[this_fighter].move_fighter(-1,-1);
							my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							break;
						case 2: //N
							my_fighter[my_map[fighter_x-1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1,0);

							break;
						case 4: //NE
							my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(-1, 1);
							break;
						case 8: //W
							my_fighter[my_map[fighter_x][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0,-1);
							break;
						case 16: //E
							my_fighter[my_map[fighter_x][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter(0, 1);
							break;
						case 32: //SW
							my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,-1);
							break;
						case 64: //S
							my_fighter[my_map[fighter_x+1][fighter_y]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1,0);
							break;
						case 128: //SE
							my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
							//my_fighter[this_fighter].move_fighter( 1, 1);
							break;

						case 129://SE || NW
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							break;
						case 36://NE || SW
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							else
							{
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 33://NW || SW
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							break;
						case 132://SE || NE
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							else
							{
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 5://NW || NE
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x-1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, -1);
							}
							else
							{
								my_fighter[my_map[fighter_x-1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( -1, 1);
							}
							break;
						case 160://SW || SE
							if(rand()%10 < 5)
							{
								my_fighter[my_map[fighter_x+1][fighter_y-1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, -1);
							}
							else
							{
								my_fighter[my_map[fighter_x+1][fighter_y+1]-1].change_health(fighter_team, attack_strength, defense_strength);
								//my_fighter[this_fighter].move_fighter( 1, 1);
							}
							break;					
					}
				}
			}
			


		}
		//VIDEO STUFF
		display_fighters(fb, rmode, my_fighter[this_fighter]);	//output to buffer the fighter
	}
}



//Use flood fill to position the army
void seed_fighters(int x, int y, int team,int team_size)
{
	std::queue<temp_fighters> fighter_queue;

	temp_fighters temp_fighter; 
	
	temp_fighter.x = x;
	temp_fighter.y = y;
	temp_fighter.team = team;

	int initialised_fighters = team_size*team;

	fighter_queue.push(temp_fighter);

	do
	{	
		temp_fighter = fighter_queue.front();
		fighter_queue.pop();		
		
		my_map[temp_fighter.x][temp_fighter.y] = 0;

		if(initialised_fighters < team_size*(team+1))
		{		
			
			fighter this_fighter;

			this_fighter.x = temp_fighter.x;
			this_fighter.y = temp_fighter.y;
			this_fighter.team = temp_fighter.team;

			my_fighter[initialised_fighters] = this_fighter;			
			my_map[this_fighter.x][this_fighter.y] = initialised_fighters+1;

			initialised_fighters++;

			x = temp_fighter.x;
			y = temp_fighter.y;

			//change this bit to reflect fighters...
			if(x<map_x-2 && x>0 && y<map_y-2 && y>0)
			{			
				if(my_map[temp_fighter.x+1][temp_fighter.y] ==0)
				{
					temp_fighter.x = x+1;
					fighter_queue.push(temp_fighter);
					//my_map[temp_fighter.x][temp_fighter.y] = temp_fighter.team;
					my_map[temp_fighter.x][temp_fighter.y] = 1;
					temp_fighter.x = x;
				}
				if(my_map[temp_fighter.x-1][temp_fighter.y-1] ==0)
				{
					temp_fighter.x = x-1;
					fighter_queue.push(temp_fighter);
					//my_map[temp_fighter.x][temp_fighter.y] = temp_fighter.team;
					my_map[temp_fighter.x][temp_fighter.y] = 1;
					temp_fighter.x = x;
				}
				if(my_map[temp_fighter.x][temp_fighter.y+1] ==0)
				{
					temp_fighter.y = y+1;
					fighter_queue.push(temp_fighter);
					//my_map[temp_fighter.x][temp_fighter.y] = temp_fighter.team;
					my_map[temp_fighter.x][temp_fighter.y] =1;
					temp_fighter.y = y;
				}
				if(my_map[temp_fighter.x-1][temp_fighter.y-1] ==0)
				{
					temp_fighter.y = y-1;
					fighter_queue.push(temp_fighter);
					//my_map[temp_fighter.x][temp_fighter.y] = temp_fighter.team;
					my_map[temp_fighter.x][temp_fighter.y] = 1;
					temp_fighter.y = y;
				}
			}
		}		
	}
	while(!fighter_queue.empty());
}



//clear the grad_grid and set the my_map as being grad_grid
void display_map(void *xfb, GXRModeObj *rmode)
{
	u32 *fb;
	fb = (u32*)xfb;

	for(int _map_x = 0; _map_x < map_x; _map_x++)
	{
		for(int _map_y = 0; _map_y < map_y; _map_y++)
		{

			if(my_map[_map_x][_map_y] == -1)
			{
				grad_grid[0][_map_x][_map_y] = my_map[_map_x][_map_y];
				grad_grid[1][_map_x][_map_y] = my_map[_map_x][_map_y];
				grad_grid[2][_map_x][_map_y] = my_map[_map_x][_map_y];
				grad_grid[3][_map_x][_map_y] = my_map[_map_x][_map_y];
				
				//VIDEO STUFF
				fb[rmode->fbWidth/VI_DISPLAY_PIX_SZ*_map_y + (_map_x/2)] = COLOR_GRAY;
			}
			else
			{
				grad_grid[0][_map_x][_map_y] = 0;
				grad_grid[1][_map_x][_map_y] = 0;
				grad_grid[2][_map_x][_map_y] = 0;
				grad_grid[3][_map_x][_map_y] = 0;
			}
		}
	}



}


//populate my_map with one of the preset maps (map3 is random)
void generate_map(int map_no)
{
	switch(map_no)
	{
		case 1:
			for(int _map_x = 0; _map_x < map_x; _map_x++)
			{
				for(int _map_y = 0; _map_y < map_y; _map_y++)
				{
					my_map[_map_x][_map_y] = 0;
					if(_map_x == 0 || _map_x == map_x-1 ||_map_y == 0 || _map_y == map_y-1)
						my_map[_map_x][_map_y] = -1;

					if(_map_x > 3 && _map_x < 200 && _map_y > 250 && _map_y < 253)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 50 && _map_x < 53 && _map_y > 40 && _map_y < 248)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 50 && _map_x < 200 && _map_y > 50 && _map_y < 200)
						if(_map_x == _map_y || _map_x == _map_y-1 || _map_x == _map_y+1)
							my_map[_map_x][_map_y] = -1;
				}
			}
			break;

		case 2:
			for(int _map_x = 0; _map_x < map_x; _map_x++)
			{
				for(int _map_y = 0; _map_y < map_y; _map_y++)
				{
					my_map[_map_x][_map_y] = 0;
					
					if(_map_x == 0 || _map_x == map_x-1 ||_map_y == 0 || _map_y == map_y-1)
						my_map[_map_x][_map_y] = -1;
		
					if(_map_x > 10 && _map_x < 240 && _map_y > 10 && _map_y < 13)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 238 && _map_x < 240 && _map_y > 10 && _map_y < 240)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 10 && _map_x < 240 && _map_y > 238 && _map_y < 240)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 10 && _map_x < 13 && _map_y > 100 && _map_y < 240)
						my_map[_map_x][_map_y] = -1;

					if(_map_x > 10 && _map_x < 100 && _map_y > 100 && _map_y < 103)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 100 && _map_x < 103 && _map_y > 100 && _map_y < 200)
						my_map[_map_x][_map_y] = -1;
					if(_map_x > 50 && _map_x < 103 && _map_y > 200 && _map_y < 203)
						my_map[_map_x][_map_y] = -1;
				}
			}
			break;
		case 3:			
			for(int _map_x = 0; _map_x < map_x ; _map_x++)
			{			
				for(int _map_y = 0; _map_y < map_y ; _map_y++)
				{
					my_map[_map_x][_map_y] = 0;
				}
			}


			srand(time(NULL));
			
			for(int _map_x = 0; _map_x < map_x ; _map_x++)
			{
				my_map[_map_x][0] = -1;
				my_map[_map_x][map_y-1] = -1;

			}
			for(int _map_y = 0; _map_y < map_y ; _map_y++)
			{
				my_map[0][_map_y] = -1;
				my_map[map_x-1][_map_y] = -1;
			}		

			for(int horizontal_lines = 0; horizontal_lines < (rand()%10)+3; horizontal_lines++)
			{
				int hor_A = rand()%(map_x-5)+3;
				int hor_B = rand()%(map_x-5)+3;

				if(hor_B < hor_A)
                {
                    int temp = hor_B;
                    hor_B = hor_A;
                    hor_A = temp;
                }
				
				int line_pos = rand()%(map_y-6)+2;
				for(int _x = hor_A; _x<hor_B; _x++)
				{
					my_map[_x][line_pos] = -1;
					my_map[_x][line_pos+1] = -1;
					my_map[_x][line_pos+2] = -1;
				}
				
			}

			for(int vertical_lines = 0; vertical_lines < (rand()%10)+3; vertical_lines++)
			{
				int ver_A = rand()%(map_x-5)+3;
				int ver_B = rand()%(map_x-5)+3;

				if(ver_B < ver_A)
                {
                    int temp = ver_B;
                    ver_B = ver_A;
                    ver_A = temp;
                }
				
				int line_pos = rand()%(map_x-6)+2;
				for(int _y = ver_A; _y<ver_B; _y++)
				{
					my_map[line_pos][_y] = -1;
					my_map[line_pos+1][_y] = -1;
					my_map[line_pos+2][_y] = -1;
				}				
			}
			break;
	}

}





//checn that position isnt located inside a box
bool check_position(int x, int y)
{
	int check_grid[map_x][map_y];
	std::queue<gradient> gradient_queue;

	gradient temp_grad;
	temp_grad.x = x;
	temp_grad.y = y;
	temp_grad.value = 1;

	int interations = 0;	
	
	//put first position onto queue

	gradient_queue.push(temp_grad);
	
	do
	{		
		//look at the front element then throw first element away...
		
		temp_grad = gradient_queue.front();
		gradient_queue.pop();
		interations++;
		
		x = temp_grad.x;
		y = temp_grad.y;

		if( x == 1 || x == map_x-2||
			y == 1 || y == map_y-2 )
		{
			return true;
		}

		check_grid[x][y] = 1;
			
		if (x >= map_x - 2 || x <= 0 || y >= map_y - 2 || y <= 0) continue;
				
		if(check_grid[temp_grad.x+1][temp_grad.y]  != 1	)
		{
			temp_grad.x = x+1;
			gradient_queue.push(temp_grad);
			check_grid[temp_grad.x][temp_grad.y] = 1;
			temp_grad.x = x;
		}
		if(check_grid[temp_grad.x][temp_grad.y-1] != 1)
		{
			temp_grad.y = y-1;
			gradient_queue.push(temp_grad);
			check_grid[temp_grad.x][temp_grad.y] = 1;
			temp_grad.y = y;
		}
		if(check_grid[temp_grad.x][temp_grad.y+1]  != 1)
		{
			temp_grad.y = y+1;
			gradient_queue.push(temp_grad);
			check_grid[temp_grad.x][temp_grad.y] = 1;
			temp_grad.y = y;
		}
		if(check_grid[temp_grad.x-1][temp_grad.y]  != 1)
		{
			temp_grad.x = x-1;
			gradient_queue.push(temp_grad);
			check_grid[temp_grad.x][temp_grad.y] = 1;
			temp_grad.x = x;
		}
		
		if(interations >= 50000)
			break;
	}
	while(!gradient_queue.empty());

	return false;
}
